=== debian/changelog ===
rustc (1.16.0+dfsg1-1~exp1ubuntu1) zesty; urgency=medium

  * Merge with Debian; remaining changes:
    - Bootstrap using the rustc version in the archive, on all architectures.
    - Work around a GCC 4.8 ICE on AArch64.
    - Use alternative build dependencies on cmake3 and binutils-2.26 for
      builds on 14.04 LTS (trusty).
    - debian/make_orig-dl_tarball.sh: Include all Ubuntu architectures.
    - debian/rules: Ignore test results for now.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 17 Mar 2017 14:47:24 +0100

rustc (1.16.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release
  * u-ignoretest-jemalloc.patch removed (applied upstream)

 -- Sylvestre Ledru <sylvestre@debian.org>  Fri, 17 Mar 2017 10:33:46 +0100

rustc (1.15.1+dfsg1-1~exp1ubuntu1) zesty; urgency=medium

  * Merge with Debian; remaining changes:
    - Bootstrap using the rustc version in the archive, on all architectures.
    - Work around a GCC 4.8 ICE on AArch64.
    - Use alternative build dependencies on cmake3, binutils-2.26, antlr and
      default-jdk for builds on 14.04 LTS (trusty).
    - debian/make_orig-dl_tarball.sh: Include all Ubuntu architectures.
    - debian/rules: Ignore test results for now.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 01 Mar 2017 14:29:01 +0100

rustc (1.15.1+dfsg1-1~exp3) experimental; urgency=medium

  * Ignore atomic-lock-free tests on armhf.
  * Update ignoretest-armhf_03.patch for newer 1.15.1 behaviour.
  * Tidy up some other patches to do with ignoring tests.

 -- Ximin Luo <infinity0@debian.org>  Sun, 12 Mar 2017 04:15:33 +0100

rustc (1.15.1+dfsg1-1~exp2) experimental; urgency=medium

  * Update armhf ignoretest patch.
  * Bootstrap armhf. (Closes: #809316, #834003)
  * Bootstrap ppc4el. (Closes: #839643)
  * Fix rust-lldb symlink. (Closes: #850639)

 -- Ximin Luo <infinity0@debian.org>  Thu, 02 Mar 2017 23:01:26 +0100
